#!/usr/local/bin/python
# -*- coding: cp1252 -*-
# Datei: auswahlsort.py (implementiert Sortieren durch Auswahl)
# W. Spiegel, 2004-03-17
####################################
def printListe(liste):
      """Druckt die Liste"""
      if liste == None :
            return
      for element in liste:
            print element,
      print
####################################
def datei_lesen(datei):
    """Liest eine Datei: gibt 2-Tupel zurueck
    (1,text), falls erfolgreich; (0,'') sonst"""
    try:    
        in_file = open(datei,"r")
    # Datei zum Lesen (r: read) ffnen
    except IOError:
        print '=> Konnte '+ datei + ' nicht ffnen!'
        return (0,'')
    else:    
        text = in_file.read() # Datei lesen
        in_file.close() # Datei schliessen
        ##print text      # und Inhalt ausgeben
        return (1,text)     
####################################
import random
def genArray(max):
      """gibt ein Feld mit max Zufallszahlen retour"""
      feld = []
      for i in range(max):
            neu = random.randint(1,10*max)  
            while (neu in feld):    # Eintrag schon in Liste?
                  #print 'suche NEUES neu: ',neu
                  neu = random.randint(0,max)                  
            feld.append(neu)
      return feld            


def auswahlSort(feld):
      """Sortieren durch Auswahl nach Rollke/Sennholz:
         Gk/Lk Informatik, S. 83/84   
      """
      verbose = 0 # 
      letztes = len(feld)
      if verbose:
            print "Grenze  Feld"
      for grenze in range(0,letztes-1):
            minStelle = grenze
            for i in range(grenze+1,letztes):
                  if (feld[i] < feld[minStelle]):
                        minStelle = i
            feld[grenze],feld[minStelle]= feld[minStelle],feld[grenze] # tauschen                  
            if verbose:
                  print grenze,
                  print ' >>> ',
                  printListe(feld)
            
      
def test():
      """testet die Sortierfunktion"""
      """Test: liste = [47,38,42,6,57,70,25] """
      import string
      liste = genArray(11)      
      print "\n\nUnsortiertes Feld >>> ",
      printListe(liste)
      auswahlSort(liste)
      print "Fertig!! \nSortiertes Feld   >>> ",
      printListe(liste)
####################################
if __name__ == "__main__": # ausprobieren      
      test()

##Testlauf:
##Unsortiertes Feld >>>  58 44 90 92 84 69 75 15 67 79 45
##Grenze  Feld
##0  >>>  15 44 90 92 84 69 75 58 67 79 45
##1  >>>  15 44 90 92 84 69 75 58 67 79 45
##2  >>>  15 44 45 92 84 69 75 58 67 79 90
##3  >>>  15 44 45 58 84 69 75 92 67 79 90
##4  >>>  15 44 45 58 67 69 75 92 84 79 90
##5  >>>  15 44 45 58 67 69 75 92 84 79 90
##6  >>>  15 44 45 58 67 69 75 92 84 79 90
##7  >>>  15 44 45 58 67 69 75 79 84 92 90
##8  >>>  15 44 45 58 67 69 75 79 84 92 90
##9  >>>  15 44 45 58 67 69 75 79 84 90 92
##Fertig!! 
##Sortiertes Feld   >>>  15 44 45 58 67 69 75 79 84 90 92
