#!/usr/local/bin/python
# -*- coding: cp1252 -*-
# Datei: baum.py (Rekursion-Bsp)
# W. Spiegel, 2004-04-02
# fehlt: loeschen (delete), bfs, min, max
#################################  
class BinKnoten:
      """Class BinKnoten: Knoten für Binärbaum"""
      def __init__ (self, inhalt=None):
            ## als Tupel:            
            self._inhalt_,self.links,self.rechts = inhalt,None,None
            ## oder lang . . .      
##            self._inhalt_ = inhalt
##            self.links = None
##            self.rechts = None

            
      def getInhalt(self):
            if (self._inhalt_ != None):
                  return self._inhalt_
      
      def ausgabe(self):
            if (self._inhalt_ != None):
                  print str(self._inhalt_)
                        

#class BinBaum(BinKnoten): ## Vererbung nicht notwendig!!
class BinBaum:                  
      """Class BinBaum: Ein Binärbaum besteht aus Knoten (!)"""
      def __init__ (self):            
            self.anker = None

      def leer(self):
            return (self.anker==None)            

      def einfuegen(self,wort):
            """Beachte die Ähnlichkeit zur Lösung von Dan Stubbs, siehe
            URL: http://www.an.psu.edu/ojj/courses/ist-240/reports/spring2001/fa-cb-bc-kf/code/python.html
            s. a. http://www.an.psu.edu/ojj/courses/ist-240/reports/spring2001/fa-cb-bc-kf/historyindex.html
            """
            _debug_ = 0
            if _debug_:
                  print "Wort: " + wort,                  
                  if (self.anker != None):
                        print ", Knoten: ",
                        self.anker.ausgabe()
                  else:
                        print            
            if self.leer():                  
                  self.anker = BinKnoten(wort)
            else:
                  self._einfuegen_(self.anker,wort)
                  
      def _einfuegen_(self,anker,wort):
            _debug_ = 0
            if _debug_:
                  print "Wort: " + wort,                  
                  if (anker != None):
                        print ", Knoten: ",
                        anker.ausgabe()
                  else:
                        print            
                  
            if wort < anker.getInhalt():
                  if anker.links:                        
                        self._einfuegen_(anker.links,wort)                        
                  else: # self.links == None!!                        
                        anker.links = BinKnoten(wort)
            else: # wort > self.anker.getInhalt()!!!
                  if anker.rechts:
                        self._einfuegen_(anker.rechts,wort)                          
                  else: # self.rechts == None!!
                        anker.rechts = BinKnoten(wort)


      def finde(self,wort):
            return self._find_(self.anker,wort)
            
      def _find_(self,anker,wort):
            try:
                  if wort == anker.getInhalt():
                        return 1
                  elif wort < anker.getInhalt():
                        return (self._find_(anker.links,wort))
                  else:
                        return (self._find_(anker.rechts,wort))
            except:     # nicht gefunden . . .
                  return 0

      ####################################
      # Druck-Routinen fuer die Ausgabe
      ####################################
      def druckePreBaum(self):
            """Druckt den Baum in PreOrder"""
            self.preOrder(self.anker)

      def druckeInBaum(self):
            """Druckt den Baum in InOrder"""
            self.inOrder(self.anker)
            
      def druckePostBaum(self):
            """Druckt den Baum in PostOrder"""
            self.postOrder(self.anker)

      def druckeBaum(self):
            """Druckt den Baum in InOrder eingerueckt"""
            self.intended(self.anker,0)
            
      def preOrder(self,anker):
            if anker == None :
                  return            
            anker.ausgabe()
            self.preOrder(anker.links)            
            self.preOrder(anker.rechts)

      def inOrder(self,anker):
            if anker == None :
                  return                        
            self.inOrder(anker.links)
            anker.ausgabe()
            self.inOrder(anker.rechts)

      def intended(self,anker,stufe):
            if anker == None :
                  return                        
            self.intended(anker.links,stufe + 1)
            print '\n'+ '   '*stufe + anker.getInhalt(),
            self.intended(anker.rechts,stufe + 1)
                  

      def postOrder(self,anker):
            if anker == None :
                  return            
            self.postOrder(anker.links)            
            self.postOrder(anker.rechts)
            anker.ausgabe()
####################################
            
##      def hole(self,wort):            
##          ## Zweite Version ohne try-except            
##            if self.inhalt == None: # nicht gefunden . . .
##                  return 0            
##            elif wort == self.inhalt:
##                  return 1
##            elif wort < self.inhalt:
##                  if (self.links == None):
##                        return 0
##                  else:
##                        return ( self.links.hole(wort) )
##            else:
##                  if (self.rechts == None):
##                        return 0
##                  else:                  
##                        return ( self.rechts.hole(wort) )



##      def hole(self,wort):
##            try:
##                  if wort == self.inhalt:
##                        return 1
##                  elif wort < self.inhalt:                  
##                        return ( self.links.hole(wort) )
##                  else:
##                        return ( self.rechts.hole(wort) )
##            except:     # nicht gefunden . . .
##                  return 0
##      def hole(self,wort):            
##          ## Zweite Version ohne try-except            
##            if self.inhalt == None: # nicht gefunden . . .
##                  return 0            
##            elif wort == self.inhalt:
##                  return 1
##            elif wort < self.inhalt:
##                  if (self.links == None):
##                        return 0
##                  else:
##                        return ( self.links.hole(wort) )
##            else:
##                  if (self.rechts == None):
##                        return 0
##                  else:                  
##                        return ( self.rechts.hole(wort) )                  
####################################
if __name__ == "__main__": # ausprobieren
      import string
      # Beispielsatz
      test_satz = "hallo wie gehts denn so?"
      test_li = string.split(test_satz)
      print '\n\n' + test_satz
      print test_li, '\n'      
      # Test der Klasse         
      baum2 = BinBaum()
      for wort in test_li:    # Baum aufbauen
            baum2.einfuegen(wort)
      # und ausgeben
      print "\nPreOrder:"         
      baum2.druckePreBaum()
      print "\nInOrder:"
      baum2.druckeInBaum()      
      print "\nPostOrder:"   
      baum2.druckePostBaum()      
      print "\nInOrder, einger\xfcckt:"   
      baum2.druckeBaum()      
##            
##      ## hole-Test
      print '\n\nfinde-Test:',
      test =  'hallo'     
      print '<' + test + '> ',
      if baum2.finde(test):
            print 'gefunden!!'
      else:
            print 'nicht gefunden!!'

##Testlauf:
##hallo wie gehts denn so?
##['hallo', 'wie', 'gehts', 'denn', 'so?'] 
##
##
##PreOrder:
##hallo gehts denn wie so? 
##InOrder:
##denn gehts hallo so? wie 
##PostOrder:
##denn gehts so? wie hallo 
##InOrder, eingerckt:
##
##         denn 
##      gehts 
##   hallo 
##         so? 
##      wie 
##
##hole-Test: <so?>  gefunden!!
            

