#!/usr/local/bin/python
# -*- coding: cp1252 -*-
# Datei: einsort.py (implementiert Sortieren durch Einfügen)
# W. Spiegel, 2004-03-13
 
####################################
def printListe(liste):
      """Druckt die Liste"""
      if liste == None :
            return
      for element in liste:
            print element,
      print
####################################
def datei_lesen(datei):
    """Liest eine Datei: gibt 2-Tupel zurueck
    (1,text), falls erfolgreich; (0,'') sonst"""
    try:    
        in_file = open(datei,"r")
    # Datei zum Lesen (r: read) ffnen
    except IOError:
        print '=> Konnte '+ datei + ' nicht ffnen!'
        return (0,'')
    else:    
        text = in_file.read() # Datei lesen
        in_file.close() # Datei schliessen
        ##print text      # und Inhalt ausgeben
        return (1,text)     
####################################
import random
def genArray(max):
      """gibt ein Feld mit max Zufallszahlen retour"""
      feld = []
      for i in range(max):
            neu = random.randint(1,10*max)  
            while (neu in feld):    # Eintrag schon in Liste?
                  #print 'suche NEUES neu: ',neu
                  neu = random.randint(0,max)                  
            feld.append(neu)
      return feld            


def sortiere(feld):
      """Sortieren durch Einfuegen nach Rollke/Sennholz:
         Gk/Lk Informatik, S. 85/86   
      """      
      verbose = 1 # 
      letztes = len(feld)
      if verbose:
            print "Grenze  Feld"
      for grenze in range(1,letztes):
            fuegeEin(feld[grenze],feld,grenze-1)
            if verbose:
                  print grenze,
                  print ' >>> ',
                  printListe(feld)
            
def fuegeEin(element,feld,i):
      while (i >= 0) and (feld[i] > element):
            feld[i+1]=feld[i]
            i = i-1
      feld[i+1]=element
      
def test():
      """testet die Sortierfunktion"""
      """Test: liste = [47,38,42,6,57,70,25] """
      import string
      liste = genArray(7)
      liste = [26, 74, 23, 9, 91, 13, 71, 64, 21, 1, 5, 7, 144, 125, 136]
      print "\n\nUnsortiertes Feld >>> ",
      printListe(liste)
      sortiere(liste)
      print "Fertig!! \nSortiertes Feld   >>> ",
      printListe(liste)
####################################
if __name__ == "__main__": # ausprobieren      
      test()

##Testlauf:
##Unsortiertes Feld >>>  61 6 33 63 70 29 62
##Grenze  Feld
##1  >>>  6 61 33 63 70 29 62
##2  >>>  6 33 61 63 70 29 62
##3  >>>  6 33 61 63 70 29 62
##4  >>>  6 33 61 63 70 29 62
##5  >>>  6 29 33 61 63 70 62
##6  >>>  6 29 33 61 62 63 70
##Fertig!! 
##Sortiertes Feld   >>>  6 29 33 61 62 63 70
