#!/usr/local/bin/python
# -*- coding: cp1252 -*-
# Datei: hash2.py (implementiert Hashing)
# W. Spiegel, 2004-03-13
#################################  
class Knoten:
      """Class Knoten: Knoten fr Liste"""
      def __init__ (self, inhalt):
            self.inhalt,self.next = inhalt, None
##            self.inhalt = inhalt            
##            self.next = None

            
      def getInhalt(self):
            return self.inhalt
      
      def getNext(self):
            return self.next
      
      def getPrev(self):
            return self.prev
      
      def laenge(self):
            if not self.leer():
                  if (self.next != None):
                        return 1 + self.next.laenge()
                  else:
                        return 1
            else:
                  return 0
            
      def leer(self):
            return (self.inhalt==None)
                
      def suche(self,wort):
            try:
                  if wort == self.inhalt:
                        return 1
                  else:
                        return ( self.next.suche(wort) )
            except:     # nicht gefunden . . .
                  return 0

      def loesche(self,wort):
            """ACHTUNG: gibt modifizierte Liste zurueck"""
            if self.suche(wort): # wort ist in liste!
                  davor = None
                  temp = self
                  while (wort != temp.inhalt):  # element suchen
                        davor = temp
                        temp = temp.next
                  if (temp.next == None): # letztes Element!
                        temp = davor
                        if (temp != None):
                              temp.next = None
                        else:
                              self.inhalt,self.next = None, None                        
                  elif (davor == None):    # erstes Element! 
                        self = temp.next
                  else: # umhaengen!
                        temp = temp.next
                        temp2 = davor
                        temp2.next = temp
                  return self
            else:
                  print 'Fehler beim Loeschen des Elementes %s' % wort
                  return self      

            
      def haengeAn(self,wort):
            _debug_ = 0
            if _debug_:
                  print "Wort: " + wort,
                  print ", Knoten: " + str(self.inhalt)
            if self.leer():
                self.__init__(wort)
            else:
                if (self.next == None):
                        self.next = Knoten(wort)
                else:        
                      self.next.haengeAn(wort)  

                
      def einfuegen(self,wort):
            """baut Liste alphabetisch auf"""
            _debug_ = 0
            if _debug_:
                  print "Wort: " + wort,
                  print ", Knoten: " + str(self.inhalt)
            if self.leer():     # Liste ist leer!
                self.__init__(wort)
            else:
                if (self.next == None) and (wort > self.inhalt):   
                        neu = Knoten(wort)
                        neu.next = self.next
                        self.next = neu                        
                elif (self.next == None) and (wort < self.inhalt):        # Stelle zum Einfuegen gefunden . . .
                        neu = Knoten(wort)
                        neu.next,neu.inhalt = self.next,self.inhalt
                        self.next,self.inhalt = neu, wort
                elif (wort < self.inhalt):   
                        neu = Knoten(wort)
                        neu.next,neu.inhalt = self.next,self.inhalt
                        self.next,self.inhalt = neu, wort
                else:    # weitersuchen                    
                        self.next.einfuegen(wort)
                      
                      
class Liste(Knoten):
      """Class LinListe: Eine lineare Liste besteht aus Knoten (!)"""
      def __init__ (self,inhalt=None):            
            self.inhalt,self.next = inhalt, None
            self.liste_ = Knoten(self.inhalt)


####################################
def printListe_(liste):
      """Druckt die Liste"""
      if liste == None :
            return
      print liste.getInhalt(),
      printListe_(liste.getNext())

def printListe(liste):
      """Druckt die Liste"""
      printListe_(liste)
      print
####################################
def datei_lesen(datei):
    """Liest eine Datei: gibt 2-Tupel zurueck
    (1,text), falls erfolgreich; (0,'') sonst"""
    try:    
        in_file = open(datei,"r")
    # Datei zum Lesen (r: read) ffnen
    except IOError:
        print '=> Konnte '+ datei + ' nicht ffnen!'
        return (0,'')
    else:    
        text = in_file.read() # Datei lesen
        in_file.close() # Datei schliessen
        ##print text      # und Inhalt ausgeben
        return (1,text)     
####################################
magicValue = 211 # alternativ: 199, sollte Primzahl sein!

def hashFun(wort):      
      wert = 0 
      for zeichen in wort:
            wert = wert + ord(zeichen)
      return wert % magicValue

def sucheEintrag(wort,hashTabelle):
      """ Sucht den Eintrag <wort> in der Hash-Tabelle"""
      if hashTabelle.has_key(hashFun(wort)):
            if hashTabelle[hashFun(wort)].suche(wort):
                  return 1
            else:
                  return 0
      else:
            return 0

      
def testHashFun():
      """Baut Hash-Tabelle auf und gibt die Einträge aus
      benutzt die Klasse Liste, s. o.
      """      
      import string
      hashTab = {}      # Hash-Tabelle
            
      pfad = "./"
      dateiname = 'wortliste.txt'
      ergebnis,text = datei_lesen(pfad+dateiname) ## 2-Tupel als retour-Wert
      
      if ergebnis == 1: # Datei-Lesen erfogreich
            textListe = string.split(text)      # Liste aufbauen
            for zeile in textListe:
                  hashValue = hashFun(zeile)    # Hash-Wert berechnen
                  if hashTab.has_key(hashValue):      # gibt es einen Eintrag in der Hash-Tabelle
                        hashTab[hashFun(zeile)].haengeAn(zeile) # ja, also anhängen
                  else:
                        hashTab[hashValue] = Liste()  # Nein, also Hash-Tabelle aufbauen
                        hashTab[hashFun(zeile)].haengeAn(zeile) # und Eintrag anhängen
            # Test der Hash-Tabelle
            print "Test für i = 6"
            if hashTab.has_key(6):
                  printListe(hashTab[6] )
            # gesamte Hash-Tabelle ausgeben
            j = 0
            for i in range(0,magicValue):
                  if hashTab.has_key(i):
                        j = j +1
                        print i,
                        printListe( hashTab[i] )
            print "\nBelegung: %6.2f  Prozent" % ((j * 100.0) / magicValue)
            print "Verhältnis der Anzahl der Wörter zur Größe der Hash-Tabelle"            
            print "Overhead: %6.2f  Prozent" % (100.0 - ((len(textListe) * 100.0) / magicValue) )
            suchWort = textListe[111]
            print "Suche den Eintrag:", suchWort 
            if sucheEintrag(suchWort ,hashTab):
                  print "=> Eintrag gefunden"
            else:
                  print ">>> Grande catastrophe . . . <<<"
            suchWort = "März"                  
            print "Suche den Eintrag:", "März"
            if sucheEintrag(suchWort ,hashTab):
                  print "=> Eintrag gefunden"
            else:                        
                  print ">>> Grande catastrophe . . . <<<"   
####################################
if __name__ == "__main__": # ausprobieren      
      testHashFun()
