#!/usr/local/bin/python
# -*- coding: cp1252 -*-
# Datei: queue.py 
# W. Spiegel, 2004-03-27
#################################                    
class Queue:
      """Class Queue: FIFO-Speicher (Warteschlange) in Python"""
      def __init__ (self,inhalt=None):
            if inhalt:
                  self._queue_ = [inhalt]
            else:
                  self._queue_ = []
            
      
      def put(self,inhalt=None):
            """Element einfuegen"""
            if (inhalt == None):
                  return 0
            else:
                self._queue_.insert(-1,inhalt)  # Element am Anfang einfuegen
                return 1

      def get(self):
            """Element holen"""
            if not self.leer():
                  return self._queue_.pop()     # Letztes Element holen
            else:
                  return None
            
      def leer(self):
            """Warteschlange leer?"""
            return (self._queue_ == [])

      def anzahl(self):
            """Gibt die Anzahl der Elemente in der Warteschlange zurueck"""
            if not self.leer():
                  i = 0
                  for element in self._queue_:
                        i = i +1
                  return i
            else:
                  return 0


      def _printQueue_(self):
            """Druckt die Warteschlange"""
            if not self.leer():
                  for element in self._queue_:
                        print element,
            else:
                  print "Stack ist leer!"
            print

####################################
if __name__ == "__main__": # ausprobieren
      import string
      # Beispielsatz
      test_satz = "hallo wie gehts denn so?"
      test_li = string.split(test_satz)
      print '\n\n' + test_satz
      print test_li, '\n'      
      # Test der Klasse         
      myQueue = Queue()

      print "Baue Warteschlange auf . . ."
      for wort in test_li:    # Warteschlange aufbauen
            myQueue.put(wort)
      # und ausgeben
      print "\nAusgabe Warteschlange:"         
      myQueue._printQueue_()

      print "Anzahl Elemente in der Warteschlange:", myQueue.anzahl()
      # Warteschlange abarbeiten mit get!
      print "Warteschlange abarbeiten . . ."
      inhalt = myQueue.get()
      i = 1
      while inhalt <> None:
            print " "*i,inhalt
            inhalt = myQueue.get()  # naechstes Element holen
            i = i + 1

##Testlauf:
##hallo wie gehts denn so?
##['hallo', 'wie', 'gehts', 'denn', 'so?'] 
##
##Baue Warteschlange auf . . .
##
##Ausgabe Warteschlange:
##so? denn gehts wie hallo
##Anzahl Elemente in der Warteschlange: 5
##Warteschlange abarbeiten . . .
##  hallo
##   wie
##    gehts
##     denn
##      so?
