#!/usr/local/bin/python
# -*- coding: cp1252 -*-
# Datei: quicksort.py (implementiert Quicksort)
# W. Spiegel, 2004-03-17 
####################################
def printListe(liste):
      """Druckt die Liste"""
      if liste == None :
            return
      for element in liste:
            print element,
      print
####################################
def datei_lesen(datei):
    """Liest eine Datei: gibt 2-Tupel zurueck
    (1,text), falls erfolgreich; (0,'') sonst"""
    try:    
        in_file = open(datei,"r")
    # Datei zum Lesen (r: read) ffnen
    except IOError:
        print '=> Konnte '+ datei + ' nicht ffnen!'
        return (0,'')
    else:    
        text = in_file.read() # Datei lesen
        in_file.close() # Datei schliessen
        ##print text      # und Inhalt ausgeben
        return (1,text)     
####################################
import random
def genArray(max):
      """gibt ein Feld mit max Zufallszahlen retour"""
      feld = []
      for i in range(max):
            neu = random.randint(1,10*max)  
            while (neu in feld):    # Eintrag schon in Liste?
                  #print 'suche NEUES neu: ',neu
                  neu = random.randint(0,max)                  
            feld.append(neu)
      return feld            


def sortiere(feld):
      """Ruft die Quicksort-Methode auf
      """
      verbose = 1
      letztes = len(feld)-1
      if verbose:
            print "li,mi,re    Feld"
      quicksort(feld,0,letztes)


def quicksort(feld,first,last):
      """Quicksort nach Rollke/Sennholz:
         Gk/Lk Informatik, S. 91-94   
      """
      verbose = 1
      if (first < last):
            mitte = (first + last) / 2
            pivot = feld[mitte]
            li = first
            re = last
            if verbose:
                  print li,mitte,re,
                  print ' >>> ',
                  printListe(feld)
            while (li <= re):
                  while (feld[li] < pivot):
                        li = li + 1
                  while (feld[re] > pivot):
                        re = re - 1
                  if (li <= re):
                        feld[li],feld[re] = feld[re],feld[li]     # tauschen
                        li = li + 1
                        re = re - 1
            if verbose:
                  print '       >>> ',
                  printListe(feld)                        
            quicksort(feld,first,re)
            quicksort(feld,li,last)

            

      
def test():
      """testet die Sortierfunktion"""
      """Test: liste = [47,38,42,6,57,70,25] """
      import string
      liste = genArray(9)
      verbose = 1
      if verbose:
            print "\n\nUnsortiertes Feld >>> ",
            printListe(liste)
      sortiere(liste)
      if verbose:      
            print "Fertig!! \nSortiertes Feld   >>> ",
            printListe(liste)
####################################
if __name__ == "__main__": # ausprobieren      
      test()

##Testlauf
##Unsortiertes Feld >>>  73 23 70 17 77 2 20 38 46
##li,mi,re    Feld
##0 4 8  >>>  73 23 70 17 77 2 20 38 46
##       >>>  73 23 70 17 46 2 20 38 77
##0 3 7  >>>  73 23 70 17 46 2 20 38 77
##       >>>  2 17 70 23 46 73 20 38 77
##0 0 1  >>>  2 17 70 23 46 73 20 38 77
##       >>>  2 17 70 23 46 73 20 38 77
##2 4 7  >>>  2 17 70 23 46 73 20 38 77
##       >>>  2 17 38 23 20 73 46 70 77
##2 3 4  >>>  2 17 38 23 20 73 46 70 77
##       >>>  2 17 20 23 38 73 46 70 77
##5 6 7  >>>  2 17 20 23 38 73 46 70 77
##       >>>  2 17 20 23 38 46 73 70 77
##6 6 7  >>>  2 17 20 23 38 46 73 70 77
##       >>>  2 17 20 23 38 46 70 73 77
##Fertig!! 
##Sortiertes Feld   >>>  2 17 20 23 38 46 70 73 77
