#!/usr/local/bin/python
# -*- coding: cp1252 -*-
# Datei: shellsort.py (implementiert Shellsort,
# verbessertes Sortieren durch Einfügen)
# W. Spiegel, 2004-03-14 
####################################
def printListe(liste):
      """Druckt die Liste"""
      if liste == None :
            return
      for element in liste:
            print element,
      print
####################################
def datei_lesen(datei):
    """Liest eine Datei: gibt 2-Tupel zurueck
    (1,text), falls erfolgreich; (0,'') sonst"""
    try:    
        in_file = open(datei,"r")
    # Datei zum Lesen (r: read) ffnen
    except IOError:
        print '=> Konnte '+ datei + ' nicht ffnen!'
        return (0,'')
    else:    
        text = in_file.read() # Datei lesen
        in_file.close() # Datei schliessen
        ##print text      # und Inhalt ausgeben
        return (1,text)     
####################################
import random
def genArray(max):
      """gibt ein Feld mit max Zufallszahlen retour"""
      feld = []
      for i in range(max):
            neu = random.randint(1,10*max)  
            while (neu in feld):    # Eintrag schon in Liste?
                  #print 'suche NEUES neu: ',neu
                  neu = random.randint(0,max)                  
            feld.append(neu)
      return feld            


def shellsort(feld):
      """Shellsort nach Sedgewick: Algorithmen, S. 136-141
      """      
      verbose = 0 # 
      letztes = len(feld)
      h = 1
      while (h <= letztes):
            h = 3*h + 1
      if verbose:            
            print "h:",h            
      while (h > 1):
            h = h / 3   # alternativ: h / 2
            if verbose:
                  print "h:",h
                  print "i       Feld"
            for i in range(h,letztes):    # statt h+1
                  j = i           
                  element = feld[i]
                  weiter = 1
                  while  (feld[j-h] > element) and weiter:
                        feld[j]=feld[j-h]
                        j = j-h
                        weiter = (j>=h)   # statt (j > h)
                  feld[j]=element
                  if verbose:                        
                        print i,
                        print ' >>> ',
                        printListe(feld)
            
      
def test():
      """testet die Sortierfunktion"""
      """Test: liste = [47,38,42,6,57,70,25] """
      """liste = [18, 25, 28, 49, 2]"""
      """liste = [93, 127, 48,141, 90, 3, 92, 134, 64, 71, 89, 110, 81, 12, 117]"""
      """liste = [80, 25, 32, 100, 81, 110, 97, 141, 107, 72, 16, 67, 6, 120, 116]"""
      """liste = [26, 74, 23, 9, 91, 13, 71, 64, 21, 1, 5, 7, 144, 125, 136]"""
      import string
      verbose = 1
      liste = genArray(17)            
      if verbose:
            print "\n\nUnsortiertes Feld >>> ",
            printListe(liste)
      liste2 = liste[:]      
      shellsort(liste)
      liste2.sort()
      if verbose:            
            print "Fertig!! \nSortiertes Feld   >>> ",
            printListe(liste)
            print "Zum Vergleich     >>> ",
            printListe(liste2)
            for i in range(len(liste)):
                  if (liste[i]<>liste2[i]):
                        print "Fehler: ", liste[i],liste2[i]


####################################
if __name__ == "__main__": # ausprobieren      
      test()

##Testlauf:
##Unsortiertes Feld >>>  42 13 45 31 63 38 47
##h: 13
##h: 6
##i       Feld
##6  >>>  42 13 45 31 63 38 47
##h: 3
##i       Feld
##3  >>>  31 13 45 42 63 38 47
##4  >>>  31 13 45 42 63 38 47
##5  >>>  31 13 38 42 63 45 47
##6  >>>  31 13 38 42 63 45 47
##h: 1
##i       Feld
##1  >>>  13 31 38 42 63 45 47
##2  >>>  13 31 38 42 63 45 47
##3  >>>  13 31 38 42 63 45 47
##4  >>>  13 31 38 42 63 45 47
##5  >>>  13 31 38 42 45 63 47
##6  >>>  13 31 38 42 45 47 63
##Fertig!! 
##Sortiertes Feld   >>>  13 31 38 42 45 47 63
