#!/usr/local/bin/python
# -*- coding: cp1252 -*-
# Datei: sort_compare.py (implementiert Shellsort,BubbleSort,
# Sortieren durch Auswahl und Sortieren durch Einfuegen im Vergleich!)
# W. Spiegel, 2004-03-17
####################################
def printListe(liste):
      """Druckt die Liste"""
      if liste == None :
            return
      for element in liste:
            print element,
      print
####################################
def datei_lesen(datei):
    """Liest eine Datei: gibt 2-Tupel zurueck
    (1,text), falls erfolgreich; (0,'') sonst"""
    try:    
        in_file = open(datei,"r")
    # Datei zum Lesen (r: read) ffnen
    except IOError:
        print '=> Konnte '+ datei + ' nicht ffnen!'
        return (0,'')
    else:    
        text = in_file.read() # Datei lesen
        in_file.close() # Datei schliessen
        ##print text      # und Inhalt ausgeben
        return (1,text)     
####################################
import random
def genArray(max):
      """gibt ein Feld mit max Zufallszahlen retour"""
      feld = []
      for i in range(max):
            neu = random.randint(1,10*max)  
            while (neu in feld):    # Eintrag schon in Liste?
                  #print 'suche NEUES neu: ',neu
                  neu = random.randint(0,max)                  
            feld.append(neu)
      return feld            

def sortiere(feld):
      """Ruft die Quicksort-Methode auf
      """
      verbose = 0
      letztes = len(feld)-1
      if verbose:
            print "li,mi,re    Feld"
      quicksort(feld,0,letztes)


def quicksort(feld,first,last):
      """Quicksort nach Rollke/Sennholz:
         Gk/Lk Informatik, S. 91-94   
      """
      verbose = 0
      if (first < last):
            mitte = (first + last) / 2
            pivot = feld[mitte]
            li = first
            re = last
            if verbose:
                  print li,mitte,re,
                  print ' >>> ',
                  printListe(feld)
            while (li <= re):
                  while (feld[li] < pivot):
                        li = li + 1
                  while (feld[re] > pivot):
                        re = re - 1
                  if (li <= re):
                        feld[li],feld[re] = feld[re],feld[li]     # tauschen
                        li = li + 1
                        re = re - 1
            if verbose:
                  print '       >>> ',
                  printListe(feld)                        
            quicksort(feld,first,re)
            quicksort(feld,li,last)

def shellsort(feld):
      """Shellsort nach Sedgewick: Algorithmen, S. 136-141
      """      
      verbose = 0 # 
      letztes = len(feld)
      h = 1
      while (h <= letztes):
            h = 3*h + 1
      if verbose:            
            print "h:",h            
      while (h > 1):
            h = h / 3   # alternativ: h / 2
            if verbose:
                  print "h:",h
                  print "i       Feld"
            for i in range(h,letztes):    # statt h+1
                  j = i           
                  element = feld[i]
                  weiter = 1
                  while  (feld[j-h] > element) and weiter:
                        feld[j]=feld[j-h]
                        j = j-h
                        weiter = (j>=h)   # statt (j > h)
                  feld[j]=element
                  if verbose:                        
                        print i,
                        print ' >>> ',
                        printListe(feld)
            
def einSort(feld):
      """Sortieren durch Einfuegen nach Rollke/Sennholz:
         Gk/Lk Informatik, S. 85/86   
      """      
      verbose = 0 # 
      letztes = len(feld)
      if verbose:
            print "Grenze  Feld"
      for grenze in range(1,letztes):
            fuegeEin(feld[grenze],feld,grenze-1)
            if verbose:
                  print grenze,
                  print ' >>> ',
                  printListe(feld)
            
def fuegeEin(element,feld,i):
      while (i >= 0) and (feld[i] > element):
            feld[i+1]=feld[i]
            i = i-1
      feld[i+1]=element

def auswahlSort(feld):
      """Sortieren durch Auswahl nach Rollke/Sennholz:
         Gk/Lk Informatik, S. 83/84   
      """
      verbose = 0 # 
      letztes = len(feld)
      if verbose:
            print "Grenze  Feld"
      for grenze in range(0,letztes-1):
            minStelle = grenze
            for i in range(grenze+1,letztes):
                  if (feld[i] < feld[minStelle]):
                        minStelle = i
            feld[grenze],feld[minStelle]= feld[minStelle],feld[grenze] # tauschen                  
            if verbose:
                  print grenze,
                  print ' >>> ',
                  printListe(feld)


def bubbleSort(feld):
      """BubbleSort (Sortieren durch Austausch) nach Rollke/Sennholz:
         Gk/Lk Informatik, S. 83/84   
      """
      verbose = 0 # 
      letztes = len(feld)
      if verbose:
            print "Grenze  Feld"
      for grenze in range(0,letztes-1):
            if verbose:
                  print "    i       Feld"

            for i in range(letztes-1,grenze,-1):                  
                  if (feld[i-1] > feld[i]):                        
                        feld[i],feld[i-1]= feld[i-1],feld[i] # tauschen
                  if verbose:
                        print ' '*3, i,
                        print ' >>> ',
                        printListe(feld)
            if verbose:
                  print grenze,
                  print ' >>> ',
                  printListe(feld)

                  
def test(anzahl=0):
      import time
      """testet die Sortierfunktion"""
      """Test: liste = [47,38,42,6,57,70,25] """
      """liste = [18, 25, 28, 49, 2]"""
      """liste = [93, 127, 48,141, 90, 3, 92, 134, 64, 71, 89, 110, 81, 12, 117]"""
      """liste = [80, 25, 32, 100, 81, 110, 97, 141, 107, 72, 16, 67, 6, 120, 116]"""
      """liste = [26, 74, 23, 9, 91, 13, 71, 64, 21, 1, 5, 7, 144, 125, 136]"""
      import string
      verbose = 0
      if (anzahl==0):
            anzahl = 451
      liste = genArray(anzahl)            
      liste2 = liste[:] ## so kopiert man Listen 
      liste3 = liste[:]
      liste4 = liste[:]
      liste5 = liste[:]
      
      davor = time.time()
      shellsort(liste)
      danach = time.time()
      zeit1 = danach - davor
      ###
      davor = time.time()
      einSort(liste2)
      #liste2.sort()
      danach = time.time()
      zeit2 = danach - davor
      ###
      davor = time.time()
      auswahlSort(liste3)
      danach = time.time()
      zeit3 = danach - davor
      ###
      davor = time.time()
      bubbleSort(liste4)
      danach = time.time()
      zeit4 = danach - davor
      ###
      davor = time.time()
      sortiere(liste5)
      danach = time.time()
      zeit5 = danach - davor
      ###
      print "\nSortieren von %i Elementen" % anzahl
      print "ShellSort:    %10.8f" % zeit1
      print "EinfuegeSort: %10.8f" % zeit2
      print "AuswahlSort:  %10.8f" % zeit3      
      print "BubbleSort:   %10.8f" % zeit4
      print "Quicksort:    %10.8f" % zeit5
      
##            print "Zum Vergleich     >>> ",
##            printListe(liste2)
##            for i in range(len(liste)):
##                  if (liste[i]<>liste2[i]):
##                        print "Fehler: ", liste[i],liste2[i]

def warte():
      eingabe = raw_input("ich warte . . . ")
####################################
if __name__ == "__main__": # ausprobieren
      zahl = 0
      try: 
            zahl = input("Wieviel Elemente? ")
      except:
            pass
      if (zahl!=0):
            test(anzahl=zahl)
      else:
            test()
      warte()
##Testlauf
##Sortieren von 1451 Elementen
##ShellSort:    0.03099990
##EinfuegeSort: 0.57800007
##AuswahlSort:  0.51600003
##BubbleSort:   1.26600003
##Quicksort:    0.01499987
##Sortieren von 2437 Elementen
##ShellSort:    0.06199980
##EinfuegeSort: 1.51600003
##AuswahlSort:  1.50000000
##BubbleSort:   3.76500010
##Quicksort:    0.04699993
